/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/
/**
 * \file CubeIndexMarker.h
 * \brief Provides a static merthod to check the marker of the index at the beginning of file. ( Further extension might allow checl of crc sum, or another correctness checks)
 */


#ifndef __INDEX_MARKER_H
#define __INDEX_MARKER_H
#include <utility>
#include <vector>
#include <istream>
#include <inttypes.h>
#include <fstream>
using namespace std;






namespace cube
{
/**
 * Defines an interface for all kinds of Indecies, used in Cube.
 */
class IndexMarker
{
private:
    static const string marker;
public:

    static bool
    checkMarker( fstream& in );
    static bool
    checkMarker( FILE* in );
    static bool
    writeMarker( fstream& in );
    static bool
    writeMarker( FILE* in );

    static size_t
    markerSize()
    {
        return marker.size();
    }
};
}
#endif
