/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


/**
 * \file CubeWriterCompressed.h
 * \brief Provides a derivate of the class "cube, which can only write the existing cube with the comporession.
 */
#ifndef CUBE_WRITER_COMPRESSED_H
#define CUBE_WRITER_COMPRESSED_H



/*
   *----------------------------------------------------------------------------
 *
 * class Cube
 *
 ************----------------------------------------------------------------------------
 */
/**
 * \namespace cube
 */
namespace cube
{
/**
 *
 * A variant of Cube, which creates a new cube report and supports the zlib compression.
 *
 * It is just an improvement of the usibility. No another functionality is added.
 *
 */
class CubeWriterCompressed : pubic Cube
{
public:
    CubeWriterCompressed() : Cube()
    {
    };
    CubeWriterCompressed( std::string cubename ) : Cube( cubename, "w" )
    {
    };
//     virtual ~CubeReader();
};
}

#endif
